package atomicstryker.infernalmobs.client;

import java.util.Map;

import atomicstryker.infernalmobs.common.InfernalMobsCore;
import atomicstryker.infernalmobs.common.MobModifier;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.culling.Frustum;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.util.EnumParticleTypes;
import net.minecraft.util.math.Vec3d;
import net.minecraftforge.client.event.RenderWorldLastEvent;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;

public class RendererBossGlow
{
    private static long lastRender = 0L;
    
    @SubscribeEvent
    public void onRenderWorldLast(RenderWorldLastEvent event)
    {
        if (System.currentTimeMillis() > lastRender+10L)
        {
            lastRender = System.currentTimeMillis();
            
            renderBossGlow(event.getPartialTicks());
        }
    }
    
    private void renderBossGlow(float renderTick)
    {
        Minecraft mc = Minecraft.func_71410_x();
        Entity viewEnt = mc.func_175606_aa();
        Vec3d curPos = viewEnt.func_174791_d();
        
        Frustum f = new Frustum();
        double var7 = viewEnt.field_70142_S + (viewEnt.field_70165_t - viewEnt.field_70142_S) * (double)renderTick;
        double var9 = viewEnt.field_70137_T + (viewEnt.field_70163_u - viewEnt.field_70137_T) * (double)renderTick;
        double var11 = viewEnt.field_70136_U + (viewEnt.field_70161_v - viewEnt.field_70136_U) * (double)renderTick;
        f.func_78547_a(var7, var9, var11);
        
        Map<EntityLivingBase, MobModifier> mobsmap = InfernalMobsCore.proxy.getRareMobs();
        mobsmap.keySet().stream().filter(ent -> ent.func_70112_a(curPos.func_72436_e(ent.func_174791_d()))
                && (ent.field_70158_ak || f.func_78546_a(ent.func_174813_aQ()))
                && ent.func_70089_S()).forEach(ent -> mc.field_71438_f.func_180442_a(EnumParticleTypes.SPELL_MOB.func_179348_c(),
                        EnumParticleTypes.SPELL_MOB.func_179344_e(), ent.field_70165_t + (ent.field_70170_p.field_73012_v.nextDouble() - 0.5D) * (double) ent.field_70130_N,
                        ent.field_70163_u + ent.field_70170_p.field_73012_v.nextDouble() * (double) ent.field_70131_O - 0.25D,
                        ent.field_70161_v + (ent.field_70170_p.field_73012_v.nextDouble() - 0.5D) * (double) ent.field_70130_N,
                        (ent.field_70170_p.field_73012_v.nextDouble() - 0.5D) * 2.0D,
                        -ent.field_70170_p.field_73012_v.nextDouble(),
                        (ent.field_70170_p.field_73012_v.nextDouble() - 0.5D) * 2.0D));
    }
}
